%% Preliminaries
clearvars
%The length of each sequence.
% slen=[5	4	5	3	5	4	5	2	5	4	5	3	5	4	5	1	5	4	5	3	5	4	5	2	5	4	5	3	5	4	5];
% rlslen=repmat(slen,1,2);

% number of each sequence needed to fill unit intervals.
%nseqs=[167	33	22	28	23	13	14	33	31	11	10	15	17	12	15	56	56	15	12	17	15	10	11	31	33	14	13	23	28	22	33	167];
FareyRatios=[0.167
0.200
0.222
0.250
0.273
0.286
0.300
0.333
0.364
0.375
0.385
0.400
0.417
0.429
0.444
0.500
0.556
0.571
0.583
0.600
0.615
0.625
0.636
0.667
0.700
0.714
0.727
0.750
0.778
0.800
0.833
0.867];

%load SB tree matrix: M, 62X5, NaNs fill empty entries
load RandLSeqMatrix.mat
M(32:62,:)=[];
M=M'; %now 5X31;

%generate sequences
SequenceMatrix=NaN(5,1000);


seqcount=1;
spoint=151;
%Place sequences in Matrix to be indexed and pulled by model
for i=1:31

   cpoint=FareyRatios(i,1)*1000;
   epoint=round((FareyRatios(i+1,1)*1000 - cpoint) /2,0)+cpoint;
   
   len=epoint-spoint+1;

   subseq=repmat(M(:,seqcount),1,len);
   SequenceMatrix(:,spoint:epoint)=subseq;
   seqcount=seqcount+1;
   
   spoint=epoint+1;

end

%SequenceMatrix(1:5,1)=zeros(5,1);
%SequenceMatrix(1:5,473:528)=NaN(5,56);
%SequenceMatrix(1:5,901:1000)=zeros(5,100);
%LLLL
SequenceMatrix(1:5,941:1000)=zeros(5,60);
%LRLRL
SequenceMatrix(1,871:940)=zeros(1,70);
SequenceMatrix(2,871:940)=ones(1,70);
SequenceMatrix(3,871:940)=zeros(1,70);
SequenceMatrix(4,871:940)=ones(1,70);
SequenceMatrix(5,871:940)=zeros(1,70);
%Just to see:
%SequenceMatrix=SequenceMatrix'

%%
%Parameter Settings
% The model
% K=.85; A=.85;
% %the Ratio Subset
% ratio=[.167 .45 .84 .62 .636]; %pink
% %ratio=[]; Blue
% N=100;
% %The sampling weights.
% %samp=[.3 .1 .5  .1  0;
% %       0 .5  0 .2  .3
% %       0  0  0 .05 .95];
% 
%old
K=.85; A=.85;
%the Ratio Subset
ratio=[.167 .83 .43 .625 .64]; %pink
%ratio=[]; Blue
N=100;
%The sampling weights.
samp=[.45 .4 0 0 .15;
       0 0 .2 0 .8;
       0 0 0 .1 .9];



rout=zeros(N,6);
 out=zeros(N,2);
SimOut=NaN(1600,N);
Scounter=1;
for j=1:4
    %Data simulation and visualization
    ind=j;
    if j>=3
            K=.92; ind=3;
    end
    for k=1:25
        
        x=NaN(1,4096);
        y=NaN(4096,1);
        x(1)=rand;
        counter=1;
        n=2;
        while counter < 4096
            omega=randsample(ratio,1,true,samp(ind,:));
            x(n)=mod(x(n-1)+omega-K/(2*pi)*(1+A*cos(2*pi*x(n-1)))*sin(2*pi*x(n-1)),1);

            seqloc=round(x(n),3)*1000;
            if seqloc==0
                seqloc=1;
            end

            y(counter:counter+4,1)=SequenceMatrix(:,seqloc);

            counter=counter+5;
            n=n+1;
        end

        y(isnan(y))=[];
        x(isnan(x))=[];
        %Stats
        SimOut(:,Scounter)=y(101:1700);
        out(Scounter,1)=spec_expon(normalize(y(101:1124)),128,.5);
        out(Scounter,2)=dfa(normalize(y(101:1124)),0,0,0);
%         subplot(4,1,1)
%         plot(1:length(x),x)
%         subplot(4,1,2)
%         plot(1:length(y),y)
%         subplot(4,4,9)
%        spec_slope_drw(normalize(y(101:1124)),128,.5);
       
        [S,~,~,rout(Scounter,1:6)]=rqa(y(101:1124),5,0,5);
          %subplot(2,2,4)
        spy(S,'k'), axis('xy'), drawnow
         title(['Bim ' num2str(Scounter)]);
         set(gcf,'PaperPosition',[0.25 0.25 8 10.5]);        
        filename=['/Users/jay/Desktop/rqaplots/BimanSim' int2str(Scounter) '.pdf'];
        print('-f1','-dpdf',filename)
        
%        subplot(4,4,13)
%        histogram(x,30)
        Scounter=Scounter+1;
    end
end

%%Data Analysis
  Q=1./(rout(:,1)./100); Lmd=rout(:,4)./1004; SDpi=sqrt(Q./(2.*Lmd));
 disp([mean(out(:,1)),mean(out(:,2)),mean(Q),mean(Lmd),mean(SDpi)])
  diffs=count_RandGENBimanModSeqDep(SimOut);
% % %subplot(3,3,8)
  figure, bar(diffs(1:62,1))
  display([out, Q, Lmd, SDpi])